#!/usr/bin/env python2
# -*- coding: utf-8 -*-
"""
Usage: python cros-safe-copy.py SRC DST

Where SRC is the source file path
      DST is the destination file path

Do a copy of flushed everytime chunks from SRC to DST. This is usefull if your
`dd` command makes your machine rebooting.

Example:
  sudo python cros-safe-copy.py NayuOS.img /dev/sda
"""

import sys, os
KiB = 1024
MiB = 1024*KiB

input = sys.argv[1]
output = sys.argv[2]
bs = 64*KiB
count = 50*MiB/bs
skip = 0

def quote(args):
  return " ".join(["'%s'" % a.replace("'", "'\\''") for a in args])

while skip * bs < os.stat(input).st_size:
  command = quote([
    "dd",
    "bs=%d" % bs,
    "count=%d" % count,
    "seek=%d" % skip,
    "skip=%d" % skip,
    "if=%s" % input,
    "of=%s" % output,
  ])
  print "$", command
  if os.system(command):
    sys.exit(1)
  skip += count
